> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://contentful.com/developers/docs/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://contentful.com/developers/docs/_mcp/server.

# Create an action

POST https://api.contentful.com/organizations/{organization_id}/app_definitions/{app_definition_id}/actions
Content-Type: application/vnd.contentful.management.v1+json

Reference: https://contentful.com/developers/docs/references/content-management-api/app-actions/create-an-action

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `organization_id` (string, required) — organization_id identifier
- `app_definition_id` (string, required) — app_definition_id identifier

### Body (application/vnd.contentful.management.v1+json)

This endpoint expects a map from string to any.

- `map from string to any`

## Response

### 201

Created - Resource created successfully

- `map from string to any`

## Examples

**Request**

```json
{
  "category": "Custom",
  "description": "Action that triggers builds for your website",
  "name": "Trigger Build",
  "parameters": [
    {
      "description": "Website you want to build",
      "id": "website",
      "name": "Website",
      "type": "Symbol"
    }
  ]
}
```

**Response**

```json
{
  "category": "Custom",
  "description": "Action that triggers builds for your website",
  "name": "Trigger Build",
  "parameters": [
    {
      "description": "Website you want to build",
      "id": "website",
      "name": "Website",
      "type": "Symbol"
    }
  ],
  "sys": {
    "appDefinition": {
      "sys": {
        "id": "<app_definition_id>",
        "linkType": "AppDefinition",
        "type": "Link"
      }
    },
    "createdAt": "2026-02-28T18:32:24.000Z",
    "createdBy": {
      "sys": {
        "id": "7BslKh9TdKGOK41VmLDjFZ",
        "linkType": "User",
        "type": "Link"
      }
    },
    "id": "6zbidGOqH...",
    "organization": {
      "sys": {
        "id": "0D9ZC8rLWiw6x5qizZGiRs",
        "linkType": "Organization",
        "type": "Link"
      }
    },
    "type": "AppAction",
    "updatedAt": "2026-02-28T18:32:24.000Z",
    "updatedBy": {
      "sys": {
        "id": "7BslKh9TdKGOK41VmLDjFZ",
        "linkType": "User",
        "type": "Link"
      }
    }
  }
}
```

**SDK Code**

```android Android
SDK currently doesn't implement this endpoint.
```

```java Java
SDK currently doesn't implement this endpoint.
```

```kotlin Kotlin
SDK currently doesn't implement this endpoint.
```

```swift Swift
We currently don't provide a CMA SDK for this platform.
```

```js-legacy JavaScript (legacy)
import { createClient } from 'contentful-management'

const client = createClient({
  accessToken: '<content_management_api_key>'
}, { type: 'legacy' })

// app action that targets an endpoint url
client
  .getOrganization('<org_id>')
  .then((org) =>
    org.createAppAction('<app_definition_id>', {
      type: "endpoint",
      url: "https://www.somewhere-else.com/action",
      category: "Notification.v1.0",
      description: "sends a notification",
      name: "Notification",
    })
  )
  .then((appAction) => console.log(appAction))
  .catch(console.error);

// app action that invokes a Contentful Function
client
  .getOrganization('<org_id>')
  .then((org) =>
    org.createAppAction('<app_definition_id>', {
      type: "function",
      function: {
        sys: {
          type: "Link",
          linkType: "Function",
          id: '<function_id>'
        }
      },
      category: "Notification.v1.0",
      description: "sends a notification",
      name: "Notification",
    })
  )
  .then((appAction) => console.log(appAction))
  .catch(console.error);
```

```javascript JavaScript
import { createClient } from 'contentful-management'

// Client init
const client = contentful.createClient({
  accessToken: '<content_management_api_key>'
})

// app action that targets an endpoint url
const endpointAppAction = await client.appAction.create(
  {
    organizationId: '<org_id>',
    appDefinitionId: '<app_definition_id>',
    appActionId: '<app_action_id>',
  },
  {
    type: "endpoint",
    url: "https://www.somewhere-else.com/action",
    category: "Notification.v1.0",
    description: "sends a notification",
    name: "Notification (Endpoint/URL Example)",
  }
);

// app action that invokes a Contentful Function
const functionAppAction = await client.appAction.create(
  {
    organizationId: '<org_id>',
    appDefinitionId: '<app_definition_id>',
    appActionId: '<app_action_id>',
  },
  {
    type: "function-invocation",
    function: {
      sys: {
        type: "Link",
        linkType: "Function",
        id: '<function_id>'
      }
    },
    category: "Notification.v1.0",
    description: "sends a notification",
    name: "Notification (Function Example)",
  }
);
```

```php PHP
SDK currently doesn't implement this endpoint.
```

```ruby Ruby
SDK currently doesn't implement this endpoint.
```

```python Python
SDK currently doesn't implement this endpoint.
```

```.net .NET
SDK currently doesn't implement this endpoint.
```